#include <stdio.h>
#include <stdlib.h>

typedef struct voo //estrutura que armazena as informacoes do voo
{
    int numero,tipo, lotacao;
    float preco;
}Voo;

typedef struct reserva //estrutura que armazena as informacoes do passageiro
{
    int identidade, numeroVoo, vaga;
    float preco;
}Reserva;

Voo *preencheVoos (Voo *aviao);
Reserva *preencheReserva (Reserva *passageiro, Voo *aviao, int *numPassageiros);
void imprimeDisponibilidade (Reserva *passageiro, int numPassageiros);
void imprimeEstatistica (Voo *aviao);

int main()
{
    int numPassageiros; //varivel que armazena a quantidade de passageiros
    Voo *aviao = preencheVoos (aviao); //prenche o vetor de estruturas com as informacoes dos voos
    Reserva *passageiro = preencheReserva (passageiro, aviao, &numPassageiros); //prenche o vetor de estruturas com as informacoes dos passageiros
    imprimeDisponibilidade (passageiro, numPassageiros); //imprime se o passageiro conseguiu vaga no voo ou no
    imprimeEstatistica (aviao); //imprime se a empresa obteve lucro ou prejuizo em cada voo
    free (aviao);//desaloca
    free (passageiro);

    return 0;
}

Voo *preencheVoos (Voo *aviao)//prenche o vetor de estruturas com as informacoes dos voos
{
    int i, j, validade = 1;
    aviao = (Voo *) malloc (10 * sizeof (Voo)); //aloca 10 voos
    for (i = 0; i < 10; i++)
    {
        do
        {
            printf ("\nDigite o numero do voo %d: ", i + 1); //pega o numero do voo
            scanf ("%d", &aviao[i].numero);
            if (aviao[i].numero < 0)
            {
                printf ("\nNumero invalido!!\n\n");
            }
            for (j = 0; j < i; j++)
            {
                if (aviao[j].numero == aviao[i].numero)
                {
                    validade = 0;
                    printf ("\nNumero do voo ja foi digitado!!\n\n");
                    break;
                }
                else
                {
                    validade = 1;
                }
            }
        }
        while (aviao[i].numero < 0 || validade == 0);

        do
        {
            printf ("\nDigite o tipo de aviao utilizado: "); //pega o tipo de aviao utilizado
            scanf ("%d", &aviao[i].tipo);
            if (aviao[i].tipo != 707 && aviao[i].tipo != 727 && aviao[i].tipo != 737)
            {
                printf ("\nNumero do voo invalido!!\n");
            }
        }
        while (aviao[i].tipo != 707 && aviao[i].tipo != 727 && aviao[i].tipo != 737);

        do
        {
            printf ("\nDigite o preco da passagem: "); //pega o preo da passagem do avio
            scanf ("%f", &aviao[i].preco);
            if (aviao[i].preco <= 0)
            {
                printf ("\nPreco invalido!!\n");
            }
        }
        while (aviao[i].preco <= 0);

        if (aviao[i].tipo == 707) //atribui a quantidade de vagas do avio de acordo com seu tipo
        {
            aviao[i].lotacao = 200;
        }
        else if (aviao[i].tipo == 727)
        {
            aviao[i].lotacao = 170;
        }
        else
        {
            aviao[i].lotacao = 120;
        }
    }
    return aviao; //retorna o vetor de estruturas preenchidas
}

Reserva *preencheReserva (Reserva *passageiro, Voo *aviao, int *numPassageiros) //prenche o vetor de estruturas com as informacoes dos passageiros
{
    int cont = 1, i = 0, j, vooExistente;
    passageiro = (Reserva *) malloc (sizeof (Reserva)); //aloca 1 posicao no vetor de estrutura passageiro
    while (i < cont)
    {
        do
        {
            printf ("\nDigite o numero da identidade do passageiro %d: ", i + 1); //pega a identidade do passageiro
            scanf ("%d", &passageiro[i].identidade);
            if (passageiro[i].identidade < 0)
            {
                printf ("\nNumero de identidade invalido!!\n");
            }
        }
        while (passageiro[i].identidade < 0);

        if (passageiro[i].identidade != 0) //se a identidade do passagiero nao for 0, pega todas as informaes
        {
            cont++;
            passageiro = (Reserva *) realloc (passageiro, cont * sizeof (Reserva)); //realoca o vetor de estrutura passageiro
            do
            {
                printf ("\nDigite o numero do voo desejado: "); //pega o numero do voo desejado
                scanf ("%d", &passageiro[i].numeroVoo);
                for (j = 0; j < 10; j++) //j vai ser a posicao do vetor de estrutura voo que o passageiro escolheu
                {
                    if (aviao[j].numero == passageiro[i].numeroVoo)//verifica se o numero do voo digitado existe
                    {
                        vooExistente = 1;
                        break;
                    }
                    else
                    {
                        vooExistente = 0;
                    }
                }
                if (vooExistente == 0)
                {
                    printf ("\nVoo Inexistente!!\n");
                }
            }
            while (vooExistente == 0);

            if (aviao[j].lotacao > 0) //verifica se h vagas no avio
            {
                passageiro[i].vaga = 1; //se passageiro[i].vaga for 1, ele conseguiu uma vaga no avio
                passageiro[i].preco = aviao[j].preco;
                (aviao[j].lotacao)--;
            }
            else
            {
                passageiro[i].vaga = 0;
            }
        }
        *numPassageiros = i; //numPassageiros recebe i, que no final vai ser a quantidade de passageiros
        i++;
    }
    return passageiro;
}

void imprimeDisponibilidade (Reserva *passageiro, int numPassageiros)//imprime se o passageiro conseguiu vaga no voo ou no
{
    int i;
    for (i = 0; i < numPassageiros; i++)
    {
        if (passageiro[i].vaga == 1) //imprime abaixo se o passageiro conseguiu vaga no avio desejado
        {
            printf ("\nIdentidade: %d", passageiro[i].identidade);
            printf ("\nNumero do Voo: %d", passageiro[i].numeroVoo);
            printf ("\nPreco: %.2f", passageiro[i].preco);
            printf ("\nRESERVA CONFIRMADA\n");
        }
        else //imprime abaixo se o passageiro no conseguiu vaga no avio desejado
        {
            printf ("\nIdentidade: %d", passageiro[i].identidade);
            printf ("\nNumero do Voo: %d", passageiro[i].numeroVoo);
            printf ("\nVOO LOTADO\n");
        }
    }
}

void imprimeEstatistica (Voo *aviao)//imprime se a empresa obteve lucro ou prejuizo em cada voo
{
    int i;
    for (i = 0; i < 10; i++)
    {
        printf ("\nVoo %d: ", aviao[i].numero);
        if (aviao[i].tipo == 707)
        {
            if (((float) aviao[i].lotacao * 100 / 200) < 40) //se menos de 40% das vagas do avio restam, houve lucro
            {
                printf ("LUCRO");
            }
            else if (((float) aviao[i].lotacao * 100 / 200) > 40) //se mais de 40% das vagas do avio restam, houve prejuizo
            {
                printf ("PREJUIZO");
            }
            else
            {
                printf ("NAO HOUVE NEM LUCRO NEM PREJUIZO"); //se 40% das vagas do avio restam, no houve nem prejuizo nem lucro
            }
        }
        else if (aviao[i].tipo == 727)
        {
            if (((float) aviao[i].lotacao * 100 / 170) < 40)
            {
                printf ("LUCRO");
            }
            else if (((float) aviao[i].lotacao * 100 / 170) > 40)
            {
                printf ("PREJUIZO");
            }
            else
            {
                printf ("NAO HOUVE NEM LUCRO NEM PREJUIZO");
            }
        }
        else
        {
            if (((float) aviao[i].lotacao * 100 / 120) < 40)
            {
                printf ("LUCRO");
            }
            else if (((float) aviao[i].lotacao * 100 / 120) > 40)
            {
                printf ("PREJUIZO");
            }
            else
            {
                printf ("NAO HOUVE NEM LUCRO NEM PREJUIZO");
            }
        }
    }
}





