#include <stdio.h>
#include <stdlib.h>

typedef struct pesquisa //estrutura que armazena as informacoes do habitante na pesquisa
{
    int idade, filhos;
    float salario;
    char sexo;
}Pesquisa;

void preenchePesquisa (Pesquisa *habitante, int numHabitantes);
float calculaMediaSalario (Pesquisa *habitante, int numHabitantes);
float calculaMediaFilhos (Pesquisa *habitante, int numHabitantes);
void imprimeInferiorSalario (Pesquisa *habitante, int numHabitantes, float mediaSalario);
void imprimeSuperiorFilhos (Pesquisa *habitante, int numHabitantes, float mediaFilhos);

int main()
{
    int numHabitantes;
    float mediaSalario, mediaFilhos;
    Pesquisa *habitante;
    do
    {
        printf ("Digite o numero de habitantes da regiao: ");
        scanf ("%d", &numHabitantes); //pega o numero de habitantes da regiao
        if (numHabitantes <= 0)
        {
            printf ("\nNumero de habitantes invalido!!\n\n");
        }
    }
    while (numHabitantes <= 0);

    habitante = (Pesquisa *) malloc (numHabitantes * sizeof(Pesquisa));//aloca o vetor de estruturas

    preenchePesquisa (habitante, numHabitantes);//preenche o vetor de estruturas

    mediaSalario = calculaMediaSalario (habitante, numHabitantes);//calcula a media de salario dos habitantes da regio
    printf ("\nMedia de salario dos habitantes da regiao: %.2f", mediaSalario);
    imprimeInferiorSalario (habitante, numHabitantes, mediaSalario);//imprime os habitantes com salario inferior a media

    mediaFilhos = calculaMediaFilhos (habitante, numHabitantes);//calcula a media de filhos dos habitantes da regiao
    printf ("\nMedia de filhos dos habitantes da regiao: %.2f", mediaFilhos);
    imprimeSuperiorFilhos (habitante, numHabitantes, mediaFilhos);//imprime os habitantes com numero de filhos superior a media

    free (habitante);//desaloca

    return 0;
}

void preenchePesquisa (Pesquisa *habitante, int numHabitantes)//preenche o vetor de estruturas
{
    int i;
    for (i = 0; i < numHabitantes; i++)
    {
        do
        {
            printf ("\nDigite a idade do habitante %d (habitante deve ser maior de idade): ", i + 1);
            scanf ("%d", &habitante[i].idade);//pega a idade do habitante
            if (habitante[i].idade < 18)
            {
                printf ("\nIdade do habitante invalida\n");
            }
        }
        while (habitante[i].idade < 18);

        do
        {
            printf ("\nDigite o sexo do habitante %d (m/f): ", i + 1);//pega o sexo do habitante
            fflush (stdin);
            scanf ("%c", &habitante[i].sexo);
            if (habitante[i].sexo != 'm' && habitante[i].sexo != 'f')
            {
                printf ("\nSexo do habitante invalido\n");
            }
        }
        while (habitante[i].sexo != 'm' && habitante[i].sexo != 'f');

        do
        {
            printf ("\nDigite o salario do habitante %d: ", i + 1);//pega o salario do habitante
            scanf ("%f", &habitante[i].salario);
            if (habitante[i].salario <= 0)
            {
                printf ("\nSalario invalido\n");
            }
        }
        while (habitante[i].salario <= 0);

        do
        {
            printf ("\nDigite o numero de filhos do habitante %d: ", i + 1);//pega o numero de filhos do habitante
            scanf ("%d", &habitante[i].filhos);
            if (habitante[i].filhos < 0)
            {
                printf ("\nNumero de filhos do habitante invalido\n");
            }
        }
        while (habitante[i].filhos < 0);
    }
}

float calculaMediaSalario (Pesquisa *habitante, int numHabitantes)//calcula a media de salario dos habitantes da regio
{
    float media, soma = 0;
    int i;
    for (i = 0; i < numHabitantes; i++)
    {
        soma += habitante[i].salario;//soma os salarios
    }
    media = soma / numHabitantes;//calcula a media
    return media;
}

float calculaMediaFilhos (Pesquisa *habitante, int numHabitantes)//calcula a media de filhos dos habitantes da regiao
{
    float media;
    int i, soma = 0;
    for (i = 0; i < numHabitantes; i++)
    {
        soma += habitante[i].filhos;//soma os numeros de filhos
    }
    media = ((float)soma / numHabitantes);//calcula a media
    return media;
}

void imprimeInferiorSalario (Pesquisa *habitante, int numHabitantes, float mediaSalario)//imprime os habitantes com salario inferior a media
{
    int i;
    printf ("\n\nHabitantes com salario inferior a media:\n");
    for (i = 0; i < numHabitantes; i++)
    {
        if (habitante[i].salario < mediaSalario)//se o salario do habitante for inferior a media, imprime suas informaes
        {
            printf ("\nHabitante %d", i + 1);
            printf ("\nIdade: %d", habitante[i].idade);
            printf ("\nSexo: %c", habitante[i].sexo);
            printf ("\nSalario: %.2f", habitante[i].salario);
            printf ("\nNumero de filhos: %d\n", habitante[i].filhos);
        }
    }
}

void imprimeSuperiorFilhos (Pesquisa *habitante, int numHabitantes, float mediaFilhos)//imprime os habitantes com numero de filhos superior a media
{
    int i;
    printf ("\n\nHabitantes com numero de filhos superior a media:\n");
    for (i = 0; i < numHabitantes; i++)
    {
        if (habitante[i].filhos > mediaFilhos)//se o numero de filhos for maior a media, imprime suas informaes
        {
            printf ("\nHabitante %d", i + 1);
            printf ("\nIdade: %d", habitante[i].idade);
            printf ("\nSexo: %c", habitante[i].sexo);
            printf ("\nSalario: %.2f", habitante[i].salario);
            printf ("\nNumero de filhos: %d\n", habitante[i].filhos);
        }
    }
}





