#include <stdio.h>
#include <string.h>

typedef struct cadastro //estrutura que armazena as informaes da candidata
{
    char nome[101];
    int idade;
    float peso, altura;
}Cadastro;

void incluiDados (Cadastro *inscricao, int numCadastradas);
int procuraCandidata (Cadastro *inscricao, int numCadastradas);
void imprimeCandidatas (Cadastro *inscricao, int numCadastradas);


int main()
{
    int numCadastradas = 0, opcao;
    Cadastro inscricao[50];
    do
    {
        printf ("\nDigite o que voce deseja fazer:\n");
        printf ("1 para incluir os dados de uma candidata\n");
        printf ("2 para pesquisar a existencia de uma candidata\n");
        printf ("3 para para imprimir os cadastros realizados em ordem alfabetica\n");
        printf ("0 para sair do programa\n");
        scanf ("%d", &opcao);//pega o que o usuario deseja fazer
        switch (opcao)
        {
            case 0:
            {
                break;//fecha o programa
            }
            case 1:
            {
                if (numCadastradas < 50)
                {
                    incluiDados (inscricao, numCadastradas);//inclui as informacoes de uma candidata
                    numCadastradas++;
                }
                else
                {
                    printf ("\n\nNao se pode incluir mais candidatas!!\n\n");
                }
                break;
            }
            case 2:
            {
                if (procuraCandidata (inscricao, numCadastradas) == 1)//verifica se uma possvel candidata j foi cadastrada
                {
                    printf ("\nCandidata esta cadastrada!\n\n");//se a funo retornar 1, ela j foi cadastrada
                }
                else//se retornar 0, ela no foi cadastrada
                {
                    printf ("\nCandidata nao esta cadastrada!\n\n");
                }
                break;
            }
            case 3:
            {
                imprimeCandidatas (inscricao, numCadastradas);//imprime as informaes das candidatas em ordem alfabtica
                break;
            }
            default:
            {
                printf ("\nOpcao invalida!!!\n\n");
            }
        }
    }
    while (opcao != 0);

    return 0;
}

void incluiDados (Cadastro *inscricao, int numCadastradas)//inclui as informacoes de uma candidata
{
    do
    {
        printf ("\nDigite o nome da candidata: ");
        fflush (stdin);
        gets (inscricao[numCadastradas].nome);//pega o nome da candidata
        if (strlen (inscricao[numCadastradas].nome) == 0)
        {
            printf ("\nNome invalido!!\n");
        }
    }
    while (strlen (inscricao[numCadastradas].nome) == 0);

    do
    {
        printf ("\nDigite a idade da candidata: ");
        scanf ("%d", &inscricao[numCadastradas].idade);//pega a idade da candidata
        if (inscricao[numCadastradas].idade < 0)
        {
            printf ("\nIdade invalida!!!\n");
        }
    }
    while (inscricao[numCadastradas].idade < 0);
    do
    {
        printf ("\nDigite o peso da candidata, em kg: ");//pega o peso da candidata
        scanf ("%f", &inscricao[numCadastradas].peso);
        if(inscricao[numCadastradas].peso <= 0)
        {
            printf ("\nPeso invalido!!!\n");
        }
    }
    while (inscricao[numCadastradas].peso <= 0);
    do
    {
        printf ("\nDigite a altura da candidata, em metros: ");
        scanf ("%f", &inscricao[numCadastradas].altura);//pega a altura da candidata
        if (inscricao[numCadastradas].altura <= 0)
        {
            printf ("\nAltura invalida!!!\n");
        }
    }
    while (inscricao[numCadastradas].altura <= 0);

    printf ("\nUsuaria Cadastrada com sucesso!!\n");
}

int procuraCandidata (Cadastro *inscricao, int numCadastradas)//verifica se uma possvel candidata j foi cadastrada
{
    int i, achouCandidata;
    char nomeCandidata[101];
    printf ("\nDigite o nome da candidata a ser procurada: ");
    fflush (stdin);
    gets (nomeCandidata);
    for (i = 0; i < numCadastradas; i++)//enquanto i no chegar no numero de pessoas cadastradas, o lao continua
    {
        if (strcmp (nomeCandidata, inscricao[i].nome) == 0)//candidata foi achada
        {
            achouCandidata = 1;
            break;
        }
        else
        {
            achouCandidata = 0;
        }
    }

    return achouCandidata;//retorna se achou a candidata ou no
}



void imprimeCandidatas (Cadastro *inscricao, int numCadastradas)//imprime as informaes das candidatas em ordem alfabtica
{
    int i, j;
    Cadastro *ordenacao[50], *aux;
    for (i = 0; i < numCadastradas; i++)
    {
        ordenacao[i] = &(inscricao[i]);//ordenacao aponta para a inscricao
    }
    for (i = 0; i < numCadastradas; i++)
    {
        for (j = 0; j < numCadastradas; j++)
        {
            if (strcmp ((*ordenacao[j]).nome, (*ordenacao[i]).nome) > 0)//se o nome em uma estrutura for maior que na outra, troca a estrutura que o ponteiro est apontando
            {
                aux = ordenacao[i];
                ordenacao[i] = ordenacao[j];
                ordenacao[j] = aux;
            }
        }
    }
    for (i = 0; i < numCadastradas; i++)//imprime o conteudo de onde o ponteiro est apontando (em ordem alfabtica)
    {
        printf ("\nNome da candidata: ");
        puts ((*ordenacao[i]).nome);
        printf ("Idade: %d", (*ordenacao[i]).idade);
        printf ("\nPeso: %.1f", (*ordenacao[i]).peso);
        printf ("\nAltura: %.2f\n", (*ordenacao[i]).altura);
    }
}


