#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct banco //estrutura que armazena as informaes do cliente do banco
{
    int numero;
    char *nome;
    float saldo, limite;
}Banco;

void preencheDados (Banco *cliente, int numClientes);
void atendeCliente (Banco *cliente, int numClientes);
void atualizaDados (Banco *cliente, int clienteAtendido, int numClientes);
void saque (Banco *cliente, int clienteAtendido);
void deposito (Banco *cliente, int clienteAtendido);
void imprimeDados (Banco *cliente, int clienteAtendido);
void imprimeSaldo (Banco *cliente, int clienteAtendido);
//Banco *abreConta (Banco *cliente, int clienteAtendido, int numClientes);


int main()
{
    int numClientes, i;
    Banco *cliente;
    do
    {
        printf ("Digite o numero de clientes do banco: ");
        scanf ("%d", &numClientes);//pega o numero de clientes no banco
        if (numClientes <= 0)
        {
            printf ("\nNumero de clientes invalido!!\n\n");
        }
    }
    while (numClientes <= 0);
    cliente = (Banco *) malloc (numClientes * sizeof (Banco));//aloca o vetor de estruturas
    for (i = 0; i < numClientes; i++)
    {
        cliente[i].nome = (char *) malloc (101 * sizeof (char));//aloca o nome do cliente
    }
    preencheDados (cliente, numClientes);//preenche os dados do vetor de estruturas
    atendeCliente (cliente, numClientes);//atende o cliente

    for (i = 0; i < numClientes; i++)
    {
        free (cliente[i].nome);
    }
    free (cliente);

    return 0;
}

void preencheDados (Banco *cliente, int numClientes)//preenche os dados do vetor de estruturas
{
    int i, j, validadeNum = 1;
    for (i = 0; i < numClientes; i++)
    {
        do
        {
            printf ("\nDigite o numero do cliente %d: ", i + 1);//pega o numero do cliente
            scanf ("%d", &cliente[i].numero);
            for (j = 0; j < i; j++)
            {
                if (cliente[i].numero == cliente[j].numero)//verifica se o numero do cliente ja foi previamente digitado
                {
                    validadeNum = 0;
                    printf ("\nNumero do cliente ja foi digitado\n!!");
                    break;
                }
                else
                {
                    validadeNum = 1;
                }
            }
            if (cliente[i].numero <= 0)
            {
                printf ("\nNumero do cliente invalido!!\n");
            }
        }
        while (validadeNum == 0 || cliente[i].numero <= 0);

        do
        {
            printf ("\nDigite o nome do cliente: ");//pega o nome do cliente
            fflush (stdin);
            gets (cliente[i].nome);
            if (strlen (cliente[i].nome) == 0)
            {
                printf ("\nNome invalido!!\n\n");
            }
        }
        while (strlen (cliente[i].nome) == 0);

        do
        {
            printf ("\nDigite o limite de credito do cliente (deve ser negativo): ");//pega o limite de credito do cliente
            scanf ("%f", &cliente[i].limite);
            if (cliente[i].limite >= 0)
            {
                printf ("\nLimite de credito invalido!!\n");
            }
        }
        while (cliente[i].limite >= 0);

        do
        {
            printf ("\nDigite o saldo do cliente: ");//pega o saldo do cliente
            scanf ("%f", &cliente[i].saldo);
            if (cliente[i].saldo < cliente[i].limite)
            {
                printf ("\nSaldo invalido (saldo deve ser maior que o limite)\n");
            }
        }
        while (cliente[i].saldo < cliente[i].limite);
    }
}

void atendeCliente (Banco *cliente, int numClientes)//atende o cliente
{
    int clienteAtendido, i, clienteExistente = 1;
    do
    {
        printf ("\nDigite o numero do cliente a ser atendido ou digite 0 para finalizar o programa:");
        scanf ("%d", &clienteAtendido);//pega o numero do cliente a ser atendido, ate que seja digitado 0
        if (clienteAtendido != 0)
        {
            for (i = 0; i < numClientes; i++)//verifica se o numero existe, e i vai ser a posicao do cliente
            {
                if (clienteAtendido == cliente[i].numero)
                {
                    clienteExistente = 1;
                    break;
                }
                else
                {
                    clienteExistente = 0;
                }
            }
            if (clienteExistente == 1)
            {
                atualizaDados (cliente, i, numClientes);//realiza as operacoes do cliente
            }
            else
            {
                printf ("\nCliente Inexistente!!\n");
            }
        }
    }
    while (clienteExistente == 0 || clienteAtendido != 0);
}

void atualizaDados (Banco *cliente, int clienteAtendido, int numClientes)
{
    int opcao;
    imprimeDados (cliente, clienteAtendido);//imprime os dados do cliente
    do
    {
        printf ("\nDigite a opcao desejada:\n");
        printf ("Digite 1 para Realizar um deposito\n");
        printf ("Digite 2 para realizar um saque\n");
        printf ("Digite 3 para verificar o saldo\n");
        /*printf ("Digite 4 para abrir uma nova conta\n"); nao ta funcionando....*/
        printf ("Digite 0 para finalizar as operacoes com a conta\n");
        scanf ("%d", &opcao);//pega a operacao que o cliente deseja fazer
        switch (opcao)
        {
            case 0:
            {
                break;//finaliza as operacoes com o cliente
            }
            case 1:
            {
                deposito (cliente, clienteAtendido);//realiza deposito
                break;
            }
            case 2:
            {
                saque (cliente, clienteAtendido);//realiza saque
                break;
            }
            case 3:
            {
                imprimeSaldo (cliente, clienteAtendido);//imprime o saldo atual do cliente
                break;
            }
            /*case 4:
            {
                cliente = abreConta (cliente, clienteAtendido, numClientes);
                break;
            }*/
            default:
            {
                printf ("\nOpcao invalida!\n");
            }
        }
    }
    while (opcao != 0);
}

void imprimeDados (Banco *cliente, int clienteAtendido)
{
    printf ("\nNumero do Cliente: %d", cliente[clienteAtendido].numero);
    printf ("\nNome: ");
    puts (cliente[clienteAtendido].nome);
    printf ("Saldo: %.2f", cliente[clienteAtendido].saldo);
    printf ("\nLimite de Credito: %.2f\n", cliente[clienteAtendido].limite);
}

void saque (Banco *cliente, int clienteAtendido)//realiza saque
{
    float saque;
    do
    {
        printf ("\nDigite quanto voce deseja retirar: ");
        scanf ("%f", &saque);//pega a quantia a ser retirada
        if (saque <= 0)
        {
            printf ("\nSaque Invalido!!\n");
        }
    }
    while (saque <= 0);
    if (cliente[clienteAtendido].saldo - saque < cliente[clienteAtendido].limite)//verifica se vai ficar menor que o limite de credito do cliente
    {
        printf ("\nVoce nao pode retirar essa quantia!!\n");
    }
    else
    {
        cliente[clienteAtendido].saldo -= saque;//decrementa o saldo
    }
}

void deposito (Banco *cliente, int clienteAtendido)//realiza deposito
{
    float quantia;
    do
    {
        printf ("\nDigite quantia a ser depositada: ");
        scanf ("%f", &quantia);//pega a quantia a ser depositada
        if (quantia <= 0)
        {
            printf ("\nQuantia invalida!!\n");
        }
    }
    while (quantia <= 0);

    cliente[clienteAtendido].saldo += quantia;//incremente o saldo
}

void imprimeSaldo (Banco *cliente, int clienteAtendido)//imprime o saldo atual do cliente
{
    printf ("\nSaldo Atual: %.2f\n", cliente[clienteAtendido].saldo);
}

/*
Banco *abreConta (Banco *cliente, int clienteAtendido, int numClientes)//abre uma nova conta pro cliente
{
    static int realoca = 1;
    int i, numValido = 1, ultimaPosicao;
    ultimaPosicao = numClientes + realoca - 1; //ultima posicao do vetor de estruturas
    cliente = (Banco *) realloc (cliente, (ultimaPosicao + 1) * sizeof (Banco));//realoca o vetor de estruturas
    strcpy (cliente[ultimaPosicao].nome, cliente[clienteAtendido].nome); //copia o nome do cliente
    do
    {
        printf ("\nDigite o numero da nova conta: ");//pega o numero da nova conta
        scanf ("%d", &cliente[ultimaPosicao].numero);
        for (i = 0; i < ultimaPosicao; i++)
        {
            if (cliente[ultimaPosicao].numero == cliente[i].numero)//verifica se o numero foi digitado anteriormente
            {
                printf ("\nNumero do cliente ja foi digitado\n!!");
                numValido = 0;
                break;
            }
            else
            {
                numValido = 1;
            }
        }
        if (cliente[ultimaPosicao].numero <= 0)
        {
            printf ("\nNumero do cliente invalido!!\n");
        }
    }
    while (cliente[ultimaPosicao].numero <= 0 || numValido == 0);

    do
    {
        printf ("\nDigite o limite de credito do cliente (deve ser negativo): ");//pega o limite de credito do cliente
        scanf ("%f", &cliente[ultimaPosicao].limite);
        if (cliente[ultimaPosicao].limite >= 0)
        {
            printf ("\nLimite de credito invalido!!\n");
        }
    }
    while (cliente[ultimaPosicao].limite >= 0);

    do
    {
        printf ("\nDigite o saldo do cliente: ");//pega o saldo do cliente
        scanf ("%f", &cliente[ultimaPosicao].saldo);
        if (cliente[i].saldo < cliente[ultimaPosicao].limite)
        {
            printf ("\nSaldo invalido (saldo deve ser maior que o limite)\n");
        }
    }
    while (cliente[ultimaPosicao].saldo < cliente[ultimaPosicao].limite);

    realoca++;

    return cliente;//return o novo vetor de estruturas
}*/

















